%define version_num	1.4.2
%define	release_num	1.2.2
%define	jabber_lib_dir	/var/lib/jabber

Summary: The Jabber IM (Instant Messaging) server.
Name: jabber
Version: %{version_num}
Release: %{release_num}
Group: System Environment/Daemons
Copyright: GPL
URL: http://www.jabber.org/
Source0: http://jabberd.jabberstudio.org/downloads/%{name}-%{version}.tar.gz
Source1: aim-transport-20020220.tar.gz
Source2: msn-transport-20020220.tar.gz
Source3: yahoo-transport-20020220.tar.gz
Source4: jud-20020220.tar.gz
Source5: conference-20020220.tar.gz
Source6: jabber.xml
Source7: aim.xml
Source8: icq.xml
Source9: msn.xml
Source10: yahoo.xml
Source11: conference.xml
Source12: jud.xml
Source13: sysconfig-jabber
Source14: jabberd.init
Source15: README.RPM
Patch0: msn-transport-flags.patch
Buildroot: %{_tmppath}/%{name}-root
Requires: /sbin/chkconfig
BuildRequires: perl
BuildArch: i386
PreReq: /etc/init.d

%description
Jabber is an XML-based, open-source system and protocol for real-time
messaging and presence notification. The first application of Jabber is
an instant messaging (IM) system similar to AOL Instant Messenger, ICQ,
MSN Instant Messenger, or Yahoo! Messenger. However, Jabber is also
being applied in the realms of wireless communications, embedded
systems, and Internet infrastructure.

%package aim
Version: 20020220
Group: System Environment/Daemons
Requires: %{name}
Summary: AOL Instant Messenger and ICQ transport.

%description aim
A transport that allows Jabber server users to connect to the AOL
Instant Messenger service (including ICQ).

%package msn
Version: 20020220
Group: System Environment/Daemons
Requires: %{name}
Summary: Microsoft Network messaging transport.

%description msn
A transport that allows Jabber server users to connect to the Microsoft
Network messaging service.

%package yahoo
Version: 20020220
Group: System Environment/Daemons
Requires: %{name}
Summary: Yahoo messaging transport.

%description yahoo
A transport that allows Jabber server users to connect to the Yahoo
messaging service.

%package conference
Version: 20020220
Group: System Environment/Daemons
Requires: %{name}
Summary: IRC-like chat system.

%description conference
An IRC-like conferencing system for Jabber.

%package jud
Version: 20020220
Requires: %{name}
Group: System Environment/Daemons
Summary: Searchable directory of Jabber users.

%description jud
The Jabber User Directory.  The JUD allows you to search for Jabber
users.

%prep
%setup -q 
%setup -q -D -T -a 1
%setup -q -D -T -a 2
%setup -q -D -T -a 3
%setup -q -D -T -a 4
%setup -q -D -T -a 5

%build
export JHOME=/var/jabber

# don't ask... weird auto* workaround =)
export CFLAGS="$CFLAGS"
export CXXFLAGS="$CFLAGS"

# build Jabber
	%configure --enable-ssl --prefix=/var/lib/jabber
	make

# build the MSN transport
	pushd msn-transport
	patch -p1 < %{PATCH0}
	OPTIONS="--prefix=%{jabber_lib_dir}/msn --with-jabberd=`pwd`/../jabberd --includedir=`pwd`/../jabberd/pth-1.4.0"
	if [ ! -f configure ]; then
		aclocal
		autoheader
		automake --include-deps --foreign --add-missing
		autoconf
	fi
	sh ./configure $OPTIONS
	make
	popd

# build the AIM transport
	pushd aim-transport
	OPTIONS="--prefix=%{jabber_lib_dir}/aim --with-jabberd=`pwd`/../jabberd --includedir=`pwd`/../jabberd/pth-1.4.0"
	if [ ! -f configure ]; then
		sh ./autogen.sh $OPTIONS
	else
		sh ./configure $OPTIONS
	fi
	make
	popd

# build the Yahoo transport
	pushd yahoo-transport
	OPTIONS="--prefix=%{jabber_lib_dir}/msn --with-jabberd=`pwd`/../jabberd --includedir=`pwd`/../jabberd/pth-1.4.0"
	if [ ! -f configure ]; then
		sh ./autogen.sh $OPTIONS
	else
		sh ./configure $OPTIONS
	fi
	make
	popd

# build the conferencing module
	pushd conference
	make
	popd

# build the JUD
	pushd jud
	make
	popd

%install
rm -rf %{buildroot}
cp %{SOURCE15} .

install -d -m 755                 %{buildroot}%{_sbindir}
install    -m 755 jabberd/jabberd %{buildroot}%{_sbindir}/jabberd
install -d -m 755                 %{buildroot}/etc/init.d
install    -m 755 %{SOURCE14}     %{buildroot}/etc/init.d/jabberd
install -d -m 755                 %{buildroot}%{jabber_lib_dir}
install -d -m 755                 %{buildroot}/var/log/jabber
install -d -m 755                 %{buildroot}/var/run/jabber
install -d -m 755                 %{buildroot}/var/spool/jabber

# configuration files
install -d -m 750                 %{buildroot}/etc/jabber.d
install    -m 640 %{SOURCE6}      %{buildroot}/etc/jabber.xml
install    -m 640 %{SOURCE7}      %{buildroot}/etc/jabber.d/aim.xml
install    -m 640 %{SOURCE8}      %{buildroot}/etc/jabber.d/icq.xml
install    -m 640 %{SOURCE9}      %{buildroot}/etc/jabber.d/msn.xml
install    -m 640 %{SOURCE10}     %{buildroot}/etc/jabber.d/yahoo.xml
install    -m 640 %{SOURCE11}     %{buildroot}/etc/jabber.d/conference.xml
install    -m 640 %{SOURCE12}     %{buildroot}/etc/jabber.d/jud.xml
install -d -m 755                 %{buildroot}/etc/
install    -m 640 %{SOURCE13}     %{buildroot}/etc/jabber
install -d -m 755                 %{buildroot}%{jabber_lib_dir}/aim/binary

# core jabbes server infrastructure libraries
for dir in jsm xdb_file pthsock dnsrv dialback conference jud; do
	strip $dir/*.so
	install -d -m 755 %{buildroot}%{jabber_lib_dir}/$dir
	install    -m 755 $dir/*.so %{buildroot}%{jabber_lib_dir}/$dir/
done

# extra transports
for transport in aim msn yahoo; do
	strip $transport-transport/src/*.so
	install -d -m 755 %{buildroot}%{jabber_lib_dir}/$transport
	install    -m 755 $transport-transport/src/*.so %{buildroot}%{jabber_lib_dir}/$transport/
done

%pre
useradd -M -r -d /var/lib/jabber -s /bin/bash -c "Jabber Server" jabber 2>/dev/null || :

%post
if [ $1 = 1 ]; then
	/sbin/chkconfig --add jabberd
fi
# Check if the cert has been copied, if not copy it
if [ -f /etc/ssl/certs/jabber.pem ];
	cp /etc/ssl/certs/server.pem /etc/ssl/certs/jabber.pem
	chown jabber.jabber /etc/ssl/certs/jabber.pem
	chmod 600 /etc/ssl/certs/jabber.pem
fi 


%preun
if [ $1 = 0 ]; then
	/etc/init.d/jabberd stop >/dev/null 2>&1 || :
	/sbin/chkconfig --del jabberd
fi

%postun
# Only if we are upgrading..
if [ "$1" -ge "1" ]; then
	/etc/init.d/jabberd condrestart >/dev/null 2>&1 || :
else
	userdel jabber 2>/dev/null || :
	groupdel jabber 2>/dev/null || :
fi

%clean
# rm -rf %{buildroot}

%files
%defattr(644, jabber, jabber, 755)
%doc README README.RPM UPGRADE
%attr(755, jabber, jabber) %{_sbindir}/jabberd
%config(noreplace)         /etc/jabber.xml
%dir                       /etc/jabber.d
%attr(755, jabber, jabber) %config /etc/init.d/jabberd
%attr(640, jabber, jabber) %config /etc/jabber
%dir                       %{jabber_lib_dir}
%dir                       %{jabber_lib_dir}/jsm
%attr(755, jabber, jabber) %{jabber_lib_dir}/jsm/*.so
%dir                       %{jabber_lib_dir}/xdb_file
%attr(755, jabber, jabber) %{jabber_lib_dir}/xdb_file/*.so
%dir                       %{jabber_lib_dir}/pthsock
%attr(755, jabber, jabber) %{jabber_lib_dir}/pthsock/*.so
%dir                       %{jabber_lib_dir}/dnsrv
%attr(755, jabber, jabber) %{jabber_lib_dir}/dnsrv/*.so
%dir                       %{jabber_lib_dir}/dialback
%attr(755, jabber, jabber) %{jabber_lib_dir}/dialback/*.so
%attr(750, jabber, jabber) %dir /var/spool/jabber
%attr(755, jabber, jabber) %dir /var/log/jabber
%attr(755, jabber, jabber) %dir /var/run/jabber

%files aim
%defattr(644, jabber, jabber, 755)
/etc/jabber.d/aim.xml
/etc/jabber.d/icq.xml
%dir                       %{jabber_lib_dir}/aim
%attr(755, jabber, jabber) %{jabber_lib_dir}/aim/*.so
%dir %{jabber_lib_dir}/aim/binary

%files msn
%defattr(644, jabber, jabber, 755)
/etc/jabber.d/msn.xml
%dir                       %{jabber_lib_dir}/msn
%attr(755, jabber, jabber) %{jabber_lib_dir}/msn/*.so

%files yahoo
%defattr(644, jabber, jabber, 755)
/etc/jabber.d/yahoo.xml
%dir                       %{jabber_lib_dir}/yahoo
%attr(755, jabber, jabber) %{jabber_lib_dir}/yahoo/*.so

%files conference
%defattr(644, jabber, jabber, 755)
/etc/jabber.d/conference.xml
%dir                       %{jabber_lib_dir}/conference
%attr(755, jabber, jabber) %{jabber_lib_dir}/conference/*.so

%files jud
%defattr(644, jabber, jabber, 755)
/etc/jabber.d/jud.xml
%dir                       %{jabber_lib_dir}/
%attr(755, jabber, jabber) %{jabber_lib_dir}/jud/*.so

%changelog
* Fri Dec 20 2002 Eric B. Lubow <eric@guardiandigital.com>
- Initial EnGarde RPM (1.4.2)
	based on RPMs by Matthias Saou <matthias.saou@est.une.marmotte.net>

* Wed Feb 20 2002 Benjamin Reed <ben@opennms.org>
- Initial RPM (1.4.2) -- based on RPMs by Matthias Saou <matthias.saou@est.une.marmotte.net>
